/************************************************************************
| * @file NanitInfo.ino
| * @author Sam4uk
| * @date 04-04-2023
| *
| * Інструкція
| * ==========
| *
| * Для початку користування бібліотекою потрібно підключити header файл
| */

#include <NanitLib.h>

/** Після підключення даного файлу вам доступні порти введення виведення
| * Для програмування доступні 12 портів в кожному порті присутні 4 піни
| * для введення виведення та два піни для живлення зовнішнього датчику
| * (+) та (-) живлення.
| * (-) є загальним для всіх портів
| * (+) позитивний полюс живлення. 1, 2, 11 та 12 порти живляться безпосе-
| * рeдньо від вбудованої акумуляторної батареї. В залежності від стану за-
| * ряду батареї напруга може бути в межах між 4,2 (повний заряд) та 2,7
| * (повний розряд) вольт. Інші порти мають стабілізовану напругу живлення
| * 5 вольт.
| *
| * Звернення до виводів
| *    P3_1
| *    ^^ ^
| *    || |
| *    || +--- Номер піна (число від 1 до 4)
| *    |+----- Номер порта (число від 1 до 12)
| *    +------ Обов'язкова ознака порт-піна
| *
\******************************************************************************/
void setup() {
  /// Функці яка виводить на вбудований дисплей повідомлення "Hello Nanit"
  /// Версію апаратної частини (плати)
  /// Версію бібліотеки
  /// Рівень зараяду батареї
  Serial.begin(NANIT_SERIAL_SPEED);
  NanitInfo();
}
void loop() {
  /// Nanit ніякої корисної роботи не виконує
}